#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl

use HTML::Template;
use ActiveState::Config qw( :path);
use PureMessage::Manager::Request qw($REQUEST %in);
use PureMessage::Manager::Widget;
use PureMessage::Manager::Config qw(%config);
use PureMessage::Manager::Lang;
use PureMessage::Manager::Response::Services::CSL;
use PureMessage::Resources::CSL;
use strict;

my $WIDGET = new PureMessage::Manager::Widget;
my $csl = PureMessage::Resources::CSL->new();
my $TABLE_WIDTH = 600;
my @CSL_DATA = ();
my %CSL_DATA = ();
my $CSL_WIDGET = undef;

my @PRIORITY = qw( ALL
                   LOG_EMERG
                   LOG_ALERT  
                   LOG_CRIT  
                   LOG_ERR  
                   LOG_WARNING 
                   LOG_NOTICE
                   LOG_INFO 
                   LOG_DEBUG
                );

# build up a hash map of priority to text const
my %PRIORITY;
my $count = 8;

foreach my $p (@PRIORITY) {
  $PRIORITY{$count--} = $p;
}




my $r = $REQUEST->get_response( 'PureMessage::Manager::Response::Services::CSL',
                                'stderr_to_stdout' =>1 );


$r->{debug} = 0;

$r->add_help(text => "Help", tab => "locserv", page => "mgr_locserv_csl" );

my $priority = $in{priority} =~ /^\d+$/ ?  $in{priority} :  8;


$r->title(text('resources_csl_title'));


_init_csl_data();
_init_csl_widget();

if ($CSL_WIDGET->read_input($REQUEST)) {
    my $data = $CSL_WIDGET->result_data;
    if ($data->{delete}) {
        foreach my $row (@{$data->{selected_data_rows}}) {
           $CSL_DATA{$row}->delete();
        }
        _init_csl_data();
        _init_csl_widget();
    } elsif ($data->{delete_all}) {
       foreach my $key (keys %CSL_DATA) {
         $CSL_DATA{$key}->delete();
       }
       _init_csl_data();
       _init_csl_widget();
    }
}

putFilterPage();

exit;

### start of subs
sub _filter {
    my @buttons = ({ type => 'hidden',
                     name => 'displayed_filter_by',
                     value => $in{filter_by},
                   },
                   { type => 'image',
                     name => 'start_filter_by',
                     icon => 'filter',
                     text => 'Filter',
                   },
                  );

  my @bd = buttons(\@buttons);
 
  # name, map, current,order
  my $PRIORITY = $WIDGET->option_list('priority',\%PRIORITY,$priority,'',[reverse (0 .. 8)]);
  
  my $filter =<<EOF;
        $bd[0]
        <table cellpadding=2 cellspacing=0>
        <tr>
          <td>Priority</td>
          <td>$PRIORITY</td>
          <td>$bd[1]</td>
          <td>$bd[2]</td>
        </tr>
        </table>
EOF

  my $data;
  $data = "<table cellpadding=0 cellspacing=0 width='$TABLE_WIDTH'>";
  $data .= "<tr><td align=right valign=top >\n";
  $data .= $WIDGET->widget( CLASS => 'PureMessage::Manager::Widget::PaneBox',
                           content => $filter,
                           width=> $TABLE_WIDTH,
                           suppress_bottom_border => 1,
                           td_extra => 'align=right valign=top nowrap',
                         )->output;
  $data .= "</td></tr>\n";
  return $data;                          

}

sub _init_csl_data {
    
    @CSL_DATA = ();
    %CSL_DATA = ();
    my $index = 0;
    my $esub = sub {
                      my $csl = shift;
                      push(@CSL_DATA,[exists($PRIORITY{$csl->{priority}}) ?
                                                $PRIORITY{$csl->{priority}} 
                                                : $csl->{priority},
                                        $csl->{alert_time},
                                        $csl->{location}->location_name() . '&nbsp',
                                        $csl->{location}->hostname() . '&nbsp;',
                                        $csl->{error_str}. '&nbsp;'
                                        ]);
                      $CSL_DATA{$index++} = $csl;
                   };
                   
    my %query = ();
    $query{priority} = $priority unless $priority == 8; # 8 == ANY
 
    eval { $csl->enumerate($esub,%query); };

    if ($@) {
      $r->raise_error($@);
      $r->send();
      exit 0;
    }

   
}

sub _init_csl_widget {

    my $tb = $r->ToolBar(
                        buttons => [[ { type=>'image',text=>'Delete',name=>'delete',icon=>'delete'},
                                      { type=>'image',text=>'Delete All',name=>'delete_all',icon=>'delete'},
                                      { type=>'image',text=>'Cancel',href=>'index.cgi',icon=>'cancel'},
                                   ]],
                        table=> [[1,3],['50%','50%']],
                      );

   $CSL_WIDGET = $WIDGET->widget(CLASS => 'PureMessage::Manager::Widget::Grid',
                            name => 'alert_grid',
                            data => \@CSL_DATA,
                            page => 0,
                            page_size => 10,
                            selectable=>1,
                            paging => 1,
                            columns=>5,
                            toolbar => $tb,
                            width=> $TABLE_WIDTH,
                            action=>'csl.cgi',
                            padding=>'<BR><BR>',
                            ddata => [
                                        { 
                                          width=>"5%",
                                          description=>'Priority',
                                          extra=>'nowrap valign=top',
                                        }, 
                                        {
                                          width=>"5%",
                                          description=>'Date',
                                          extra=>'nowrap valign=top',
                                        },
                                        { 
                                          width=>"5%",
                                          description=>'Location',
                                          extra=>'nowrap valign=top',
                                        }, 
                                        { 
                                          width=>"5%",
                                          description=>'Host',
                                          extra=>'nowrap valign=top',
                                        }, 
                                        { 
                                          width=>"80%",
                                          description=>'Text',
                                          extra=>'wrap valign=top',
                                        }, 
                                     ],
                           );   


}

sub putFilterPage() {

    $r->add_part("<form action=csl.cgi method=post name=alerts>",'start_form');
    $r->add_part("<table width=600><tr><td>");

    $r->print("<br>");
    $r->add_part(_filter(),'filter');
    $r->add_part($CSL_WIDGET,'alert_widget');
    $r->add_part("</table>");
    $r->add_part("</form>",'end_form');

    $r->send();

}


