package PureMessage::List::cfg;

use strict;
use warnings;

use Carp qw(croak);
use PureMessage::ListData::cfg;
use PureMessage::List::Base::cfg;
use PureMessage::List::Items;
use base qw(PureMessage::List::Base::cfg PureMessage::List::Items);

return 1;

#### class methods

sub _type { "list"; }

sub _parse_db {
    my($class, $instance, $userkey, $dbh) = @_;
    if(my $sth = $dbh->prepare_cached(q{
        SELECT list_value FROM cfg_listrow WHERE instance_id = ? AND userkey = ?
    })) {
        $sth->execute($instance, $userkey);
        my(@items);
        while(my($item) = ($sth->fetchrow_array)) {
            push(@items, $item);
        }
        return \@items;
    } else {
        die ref($dbh), "->prepare_cached failed: ", $dbh->errstr;
    }
}

#### object methods

sub data {
    my $self = shift;
    
    unless($self->{listdata}) {
        croak "Need source parameter to edit list data" unless($self->{source});
        $self->{listdata} =
            PureMessage::ListData::cfg->new($self->{source}, %$self, @_);
    }

    $self->{listdata};
}


1;
