package PureMessage::Resources::Resource::datastore;
use PureMessage::Resources::Resource::Base;
use base PureMessage::Resources::Resource::Base;

sub new {
    my ($CLASS,$store,%conf) = @_;
    my $self = bless(\%conf,$CLASS);
    $self->{store} = $store;
    $self;
}

sub create_local {
    my $self = shift;
    return 1 if $self->_native_local();
    return;
}

sub _native_local {
    my $self = shift;
    require PureMessage::DataStore;
    my $res = PureMessage::DataStore->new( store => "dir:$self->{name}");
    return $res;
}

sub _native_db {
    my $self = shift;
    require PureMessage::DataStore;
    my $res = PureMessage::DataStore->new(store => "cfg:$self->{name}",instance_id => $self->{instance_id});
    return $res;
}

sub autocommit {
   my ($self,$auto) = @_;
   $self->{autocommit} = $auto;
}

sub save {
}

sub checksum {
}


sub cclear {
    my ($self,$user,$key,$value) = @_;
    if ($user and $key) {
       my $native = $self->native();
       my $st = $native->get($user);
       $st->delete($key);
    } elsif($user) {
       my $native = $self->native();
       $native->delete($user);
    } else {
       my $native = $self->native();
       $native->clean();
    }
    
    
}

sub cinsert {
    my ($self,$user,$key,$value) = @_;
    my $native = $self->native();
    $st = $native->get($user);
    return unless $st;
    $st->store($key,$value);
}

sub cdelete {
    my ($self,$user,$key,$value) = @_;
    if($user and $key) {
       my $native = $self->native();
       my $st = $native->get($user);
       $st->delete($key);
    } elsif ($user) {
       my $native = $self->native();
       $native->delete($user);
    } else {
      #????
    }
}

sub cupdate {
    my ($self,$user,$key,$value) = @_;
    $self->cinsert($user,$key,$value);
}

sub enumerate {
    my ($self,$sub,$change_id) = @_;
    # TODO we have to ignore the change_id for now 
    
    eval {
        my $native = $self->native();
        &$sub($self->cfmt_clear()); # empty the destination
        foreach my $user ( $native->keys() ) {
            my $data = $native->get($user);
            foreach my $c ($data->contents) {
                &$sub($self->cfmt_insert($user,$c,$data->retrieve($c)));
            }
        }
 
    };
    $self->error($@) if $@;
}


sub _aggregate_op {
  my ($self,$op,$user,$key,$value) = @_;
  if ($op eq 'I') {
    # as a convenience we'll dump session_id's and give the size of items
    if ($key eq 'session_id') {
      return ("$user->$key = $value");
    } else {
      return ("$user->$key = (binary of length " . length($value) . ")");
    }

  }
}




1;




