#!perl

package PureMessage::Resources::Resource::map;

use strict;
use warnings;

use PureMessage::Resources::Resource::list;
use base qw(PureMessage::Resources::Resource::list);

return 1;

sub can_incremental {
  return 1;
}


sub create_local {
    my $self = shift;
    require PureMessage::Map;
    return 1 if PureMessage::Map->Available($self->{name});
    # have to add it
    my %extra = ();
    $extra{source} = $self->{attributes}->{source} if exists($self->{attributes}->{source});
    # maybe precious should be removed - PM::List::Base doesn't understand it
    my %map_config = (  id => $self->{name}, 
                        name => $self->{attributes}->{description},
                        description => $self->{attributes}->{description},
                        precious => $self->{attributes}->{precious},
                        match_type => $self->{attributes}->{match_type},
                        %extra,
                      );
    PureMessage::Map->Setup(%map_config);
    return 1; # Setup will croak if there is a problem                  
}

sub _as_item {
    $_[2] ? "$_[1]: $_[2]" : $_[1];
}

sub _native_local {
    my $self = shift;
    require PureMessage::Map;
    $self->create_local();
    my $list = PureMessage::Map->new($self->{name});
    return $list;
}

sub _native_db {
    my $self = shift;
    require PureMessage::Map;


    unless($self->{attributes}) {
      require PureMessage::Resources::Manager;
      my $temp = PureMessage::Resources::Manager->Find($self->{name});
      $self->{attributes} = $temp->{attributes};
    }
    
    # don't allow the source param from the resource def to override the 
    # cfg type
    my %custom_attributes = %{$self->{attributes}};
    delete($custom_attributes{source});

    my $list = PureMessage::Map->new(source => "cfg:$self->{name}",instance_id => $self->{instance_id},%custom_attributes);
    return $list;
}


sub _aggregate_op {
  my ($self,$op,$user,$key,$value) = @_;
  if ($op eq 'I') {
      return ("$key = $value");
  }
}

1;



